comment %
 Program		: Icmp Ping v1.0  
 Version		: 1.0
 Source Size	: 7.45 kB
 Executable Size: 3.50 kB
 Platform		: Win32 Console
 Source code best 
 viewed in		: WinAsm Studio 
 Usage			: At the DOS Command prompt in Windows, type
 				: ping <host/ip>
 				: where <host/ip> is a valid hostname or ip address 
 Purpose		: This program sends ICMP ping packets to a webhost
 				: and parses the replies recieved to determine  
 				: whether host is alive and whether it is a slow 
 				: or fast server by looking at the response time.  
 Started on 	: 07/07/2004
 Completed on	: 08/07/2004
 
 Author 		: Thomas Antony	(webmaster@thomasantony.cjb.net)
 Website		: http://www.tomasm.tk
 Compiler		: Microsoft Macro Assembler v6.14.8444
 Linker			: Microsoft Incremental Linker v5.12.8078
 Libraries used	: Masm32.lib Function Library (By Hutch)
 Dependencies	: Uses proprietary Microsoft ICMP API functions
 				: contained in Icmp.dll, which is present in all
 				: current windows versions
 Thanx to		: Hutch, for his Great MASM32 package (http://www.movsd.com)
 				: Iczelion, for his Superb tutorials (http://win32asm.cjb.net)
 				: Donkey, for helping me with MASM (http://donkey.visualassembler.com)
 				: Antonis Kyprianou,for his great WinAsm IDE (http://winasm.code4u.net)
 				: Everybody else at the MASMForum (http://www.masmforum.com) for testing
 				: this program.
 				:
 				: And last but not the least,
 				: someone, who made a PingI C++ program which helped me with this.
 				: If anybody knows him plz contact me.
 				: 
 				: If you have any questions contact me at
 				: webmaster@thomasantony.cjb.net
%
.386				; Processor model
.model flat,stdcall	; Flat memory model, STDCALL funcs	
option casemap:none	; Case Sensitive = true

; Include Files
include windows.inc		; Standard Windows Constants
include kernel32.inc	; Kernel32.dll Function Prototypes 
include user32.inc		; User32.dll Functions Prototypes
include ws2_32.inc		; ws2_32.dll Functions Prototypes
include masm32.inc		; Masm32.lib Functions Prototypes
; Import libraries and static libraries
includelib kernel32.lib	; Kernel32.dll Import Library
includelib user32.lib	; User32.dll Import Library
includelib ws2_32.lib	; ws2_32.dll Import Library
includelib masm32.lib	; Masm32.lib Import Library

; Function Prototypes
IcmpSendEcho	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
IcmpCloseHandle	PROTO	:DWORD
IcmpCreateFile	PROTO
;Constants
;ICMP Structure
ICMP_ECHO_REPLY STRUCT
  Address          DWORD      ?
  Status           DWORD      ?
  RoundTripTime    DWORD      ?
  DataSize         WORD      ?
  Reserved         WORD      ?
  DataPointer      DWORD      ?
  Options          ICMP_OPTIONS  <?>
  zData            BYTE 250 dup (?)
ICMP_ECHO_REPLY ENDS

; Data Section
.data
; Strings
AppName		db	"Ping(using Icmp.dll) v1.0",13,10,0
Usage		db	"Usage: Ping <hostname/Ip>",13,10,13,10
			db	"Programmed in MASM by:",13,10
			db	"Thomas Antony",13,10,0
CRLF		db	13,10,0

DllName		db	"Icmp.dll",0
Func1		db	"IcmpCreateFile",0
Func2		db	"IcmpSendEcho",0
Func3		db	"IcmpCloseHandle",0
; Messages
Msg_Ping	db	13,10,"Pinging %s....",0
Msg_Reply	db	13,10,"Reply from %s Time: %d ms TTL: %d ",0
Msg_Timeout	db	13,10,"Request Timed out",0
; Error messages
Err_NoDll	db	"Cannot load Icmp.dll",13,10,0
Err_Winsock	db	"Error loading winsock dll : %d",13,10,0
Err_NoHost	db	"Cannot find host: %s",13,10,0

; Uninitialized data section
.data?
; Handles
hIcmp		HANDLE		?		; Icmp Handle
hLib		HANDLE		?		; Handle to Icmp Dll
dwAddress	DWORD		?		; The destination address
; Function Pointers
pIcmpCreateFile		DWORD	?	; Pointers to the Icmp
pIcmpSendEcho		DWORD	?	; functions
pIcmpCloseHandle	DWORD	?	;
; Buffers
HostBuffer	db	256 dup(?)	; Buffer to hold cmdline arguments
OutBuffer	db	256 dup(?)	; Buffer for printout statements
; Structures
wsadata		WSADATA			<?>	; Struct to initialize winsock
icmpOptions	ICMP_OPTIONS	<?>	; options for sending ping
icmpReply	ICMP_ECHO_REPLY	<?>	; struct to hold the icmp reply

;Code Section
.code
start:			; The program entry point
	push ebx	; Reserve these registers to satisfy windows
	push esi	; :-)
	push edi	;
	
	invoke StdOut,ADDR AppName		; Prints the AppName using 
									; the masm32.lib function
	invoke LoadLibrary,ADDR DllName	; Load the Icmp Dll
	.if eax==0						; If error, exit after printing 
		invoke StdOut,Err_NoDll		; a message b4 it causes more
		jmp @x						; errors.
	.endif
	mov hLib,eax					; Save the library handle
	invoke GetProcAddress,eax,ADDR Func1	;Get pointer to 
	mov pIcmpCreateFile,eax			;IcmpCreateFile and save it
	invoke GetProcAddress,hLib,ADDR Func2	;Get pointer to 
	mov pIcmpSendEcho,eax			;IcmpSendEcho and save it
	invoke GetProcAddress,hLib,ADDR Func3	;Get pointer to
	mov pIcmpCloseHandle,eax		;IcmpCloseHandle and save it
	
	invoke WSAStartup,101h,ADDR wsadata	;Initialize the winsock dll
	.if eax!=0	;if fail, print error and exit
		invoke wsprintf,ADDR OutBuffer,ADDR Err_Winsock,eax
		invoke StdOut,ADDR OutBuffer
		jmp @x
	.endif
	invoke GetCL,1,ADDR HostBuffer	; Get the first cmdline arg
	.if eax!=1						; Print usage if no 
		invoke StdOut,ADDR Usage	; cmd argument given
		jmp @x						; and exit
	.endif
	invoke inet_addr,ADDR HostBuffer ; check if ipaddr entered
	.if eax==INADDR_NONE			; else check it for hostname 
		invoke gethostbyname,ADDR HostBuffer; convert host to ip
		.if eax==0					; exit if invalid hostname
			invoke wsprintf,ADDR OutBuffer,ADDR Err_NoHost,ADDR HostBuffer 
			invoke StdOut,ADDR OutBuffer
			jmp @x
		.endif
		mov eax,[eax+12]	; hostent -> h_addr_list
		mov eax,[eax]		; get the address in net byte order
		mov eax,[eax]		; from the arg given
	.endif
	mov dwAddress,eax		; save the ipaddress
	invoke IcmpCreateFile	; Open an Icmp Handle
	mov hIcmp,eax			; Save it
	
	invoke wsprintf,ADDR OutBuffer,ADDR Msg_Ping,ADDR HostBuffer
	invoke StdOut,ADDR OutBuffer	; Print "Pinging blah....."
	
	xor ebx,ebx	; Clear ebx to be used as a counter
	.WHILE ebx < 4	; Send the echo four times
		push ebx	; Save the counter in stack
		mov icmpOptions.Ttl,255	; fill the ICMP Options struct 
		mov icmpOptions.Tos,0	; with some default values
		mov icmpOptions.Flags,0	; mostly 0 except for the 
		mov icmpOptions.OptionsSize,0	; TimeToLive which is 255 
		mov icmpOptions.OptionsData,0	; Send the echo --|
										;				  V	
		invoke IcmpSendEcho,hIcmp,dwAddress,0,0,ADDR icmpOptions,ADDR icmpReply,SIZEOF ICMP_ECHO_REPLY+SIZEOF ICMP_OPTIONS,5000	
		.if(icmpReply.Address!=0)			; if there is a valid reply
			invoke inet_ntoa,icmpReply.Address	; get the source address in eax
			movzx ecx,icmpReply.Options.Ttl	; to avoid some problems with the stack
			invoke wsprintf,ADDR OutBuffer,ADDR Msg_Reply,eax,icmpReply.RoundTripTime,ecx
			invoke StdOut,ADDR OutBuffer	; Show the reply
		.else
			invoke StdOut,ADDR Msg_Timeout
		.endif
		pop ebx							; Pop out the counter from stack
		inc ebx							; increment counter
	.ENDW
	invoke StdOut,ADDR CRLF				; Prints a NewLine
	invoke IcmpCloseHandle,hIcmp		; Closes the Icmp Handle
	
@x:	pop edi				; Pops out all the preserved registers
	pop esi				; as windows wants
	pop ebx				;
	invoke WSACleanup	; Unload the Winsock Dll
	invoke ExitProcess,0	;Exit the program
	
; Custom functions calling Icmp functions
IcmpCreateFile proc 
	call pIcmpCreateFile
	Ret
IcmpCreateFile EndP
IcmpSendEcho proc hFile:HANDLE,ip:DWORD,sendBuf:DWORD,sendSize:DWORD,icmpinfo:DWORD,reply:DWORD,replySize:DWORD,timeout:DWORD

	push timeout	; push the parameters on to stack
	push replySize
	push reply
	push icmpinfo
	push sendSize
	push sendBuf
	push ip
	push hFile
	call pIcmpSendEcho	; call the function
	sub esp,32			; adjust the stack after call
	Ret
IcmpSendEcho EndP
IcmpCloseHandle proc hFile:HANDLE
	push hFile		; push the parameters on to stack
	call pIcmpCloseHandle	; call the function
	sub esp,4				; adjust the stack after call
	Ret
IcmpCloseHandle EndP
end start